<!doctype html>
<html lang="en">

<head>
    <title>Title</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container ">
        <h3 class="text-center mb-3 mt-2">F200-LỊCH SỬ QUAY DICE</h3>
        <div class="container mb-5 bg-light p-5">
            <h4>Thông tin người chơi</h4>
            <div class="row">
                <label for="" class="col-sm-2 text-right">Username</label>
                <input id="inp-username" type="text" class="col-sm-2 form-control bg-primary text-white">
                <label for="" class="col-sm-2 text-right ">Firstname</label>
                <input id="inp-fname" type="text" class="col-sm-2 form-control bg-primary text-white">
                <label for="" class="col-sm-2 text-right">Lastname</label>
                <input id="inp-lname" type="text" class="col-sm-2 form-control bg-primary text-white">

            </div>

        </div>
        <table id="dice-table" class="table table-bordered table-striped">
            <thead>
                <tr class="bg-primary text-white">
                    <th>Lần chơi</th>
                    <th>Kết quả</th>
                </tr>
            </thead>
        </table>
    </div>


</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const baseUrl = "http://203.171.20.210:8080/devcamp-lucky-dice";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
    // 
    // 
    var gStringUrl = window.location.href;
    var gURL = new URL(gStringUrl);
    var gUsername = gURL.searchParams.get("username");
    var gFirstname = gURL.searchParams.get("firstname");
    var gLastname = gURL.searchParams.get("lastname");
    console.log(gLastname);

    const gCOL_NAME = ["stt", "dice"]
    const gSTT_COL = 0;
    const gDICE_COL = 1;
    var gStt = 1;
    var gDices = [];
    var gDiceHistoryData = [];
    $("#dice-table").DataTable({
        columns: [
            { data: gCOL_NAME[gSTT_COL] },
            { data: gCOL_NAME[gDICE_COL] },
        ],
        columnDefs: [
            {
                targets: gSTT_COL,
                render: chuyenSTT,
            },
            {
                targets: gDICE_COL,

            }
        ]
    })
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        onPageLoadingDistoryDice();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        $("#inp-username").val(gUsername);
        $("#inp-fname").val(gFirstname);
        $("#inp-lname").val(gLastname);

    }
    function onPageLoadingDistoryDice() {
        var vUserObj = {
            username: "",
        }
        // b1 thu thập thông tin
        getDataUserName(vUserObj);
        console.log(vUserObj.username);
        // b2 kiểm tra thông tin(bỏ qua)
        // b3 xử lý

        $.ajax({
            url: baseUrl + "/dice-history?username=" + vUserObj.username,
            type: "GET",
            // async: false,
            contentType: gCONTENT_TYPE,
            success: function (paramRes) {
                console.log(paramRes)
                var vCount = 0;
                while (vCount < paramRes.dices.length) {
                    var bDice = { 'game': vCount, 'dice': paramRes.dices[vCount] };
                    gDiceHistoryData.push(bDice);
                    vCount++;
                }
                console.log(gDiceHistoryData)
                displayDiceHistory(gDiceHistoryData);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }

        })

        // b4 hiển thị
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function chuyenSTT() {
        return gStt++;
    }

    function getDataUserName(paramUser) {
        paramUser.username = $("#inp-username").val().trim();
    }
    function displayDiceHistory(paramUser) {
        var vTable = $("#dice-table").DataTable();
        vTable.rows.add(paramUser);
        vTable.draw();
    }



</script>

</html>